#include "keys.h"
#include <string.h>
#include <stdlib.h>

typedef struct {
    skillerctl_keyaddr_t addr;
    char*                name;
} keyaddr_name_pair; 

keyaddr_name_pair keycodeLUT[] = {
    SK_KEY_ESC,     "esc",
    SK_KEY_F1,      "f1",
    SK_KEY_F2,      "f2",
};

skillerctl_keyaddr_t skillerctl_keyaddr(const char* name)
{
    size_t n = sizeof(keycodeLUT) / sizeof(keyaddr_name_pair); 
    keyaddr_name_pair *current;
        
    for (int i = 0; i < n; i++) {
        current = keycodeLUT + i;
          
        if (strcmp(current->name, name) == 0) {
            return current->addr;
        }
    }

    return SK_KEY_BAD;
}
