#ifndef SKILLER_H
#define SKILLER_H

#include <inttypes.h>
#include <stdlib.h>
#include "keys.h"

#define SK_MAX_PAYLOAD 56
#define SK_PACKET_SIZE 64

#define SK_MAGIC     0x04

#define SK_CMD_COLOR   0x11
#define SK_CMD_ENABLE  0x01
#define SK_CMD_DISABLE 0x02

typedef struct {
    uint8_t  magic;
    uint16_t checksum;
    uint8_t  command;
    uint16_t address;
    uint8_t  length;
    uint8_t  payload[SK_MAX_PAYLOAD];
} skillerctl_packet_t;

typedef struct {
    struct { 
        uint8_t r;
        uint8_t g;
        uint8_t b;
    } color[SK_MAX_PAYLOAD / 3];
} skillerctl_payload_color_t;

void skillerctl_make_packet(skillerctl_packet_t *packet, uint8_t command, uint16_t address, void* payload, uint8_t size);

void skillerctl_color_command(skillerctl_packet_t *packet, skillerctl_keyaddr_t address, uint32_t color);
void skillerctl_enable_command(skillerctl_packet_t *packet);
void skillerctl_disable_command(skillerctl_packet_t *packet);

skillerctl_packet_t* skillerctl_unpack(skillerctl_packet_t *packet, uint8_t *data, size_t length);
void*                skillerctl_pack(skillerctl_packet_t *packet, uint8_t *data);

uint16_t skillectl_packet_checksum(skillerctl_packet_t *packet);

#endif /* SKILLER_H */

